#include <stdio.h>
#include <iostream>
#include <vector>
#include <map>
#include <string>
#include <algorithm>

using namespace std;

std::string readValue()
{
	std::string str;
	std::cin >> str;
	size_t pos = str.find('*');
	std::string front = str.substr(0, pos);
	std::string back;
	if (pos != str.npos) {
	    back = str.substr(pos + 1);
	}
	std::string middle(9 - (front.size() +  back.size()), '?');
//	std::cout << front << "+" << middle << "+" << back << "\n";
	return front + middle + back;
}


struct Reader {

	Reader( vector<int> &list) : list(list)
	{}

	vector<int> &list;
	int i=0;
};

int main()
{
    int i;
    std::cin >> i;
    map<int,vector<int>> index;
    string s;
    for (; i > 0; --i) {
	//std::string v = readValue();
	cin >> s;
	for (int pos=0; pos<s.size(); ++pos)
		index[pos*10+s[pos]-'0'].push_back(atol (s.data()));
    }

    for (auto &x : index) {
	    sort(x.second.begin(), x.second.end());
    }

    std::cin >> i;
    std::string value;

    for (; i > 0; --i) {
	value = readValue();

	//std::cout << value << "\n";
	bool done = false;

	int cnt =0;
	vector<Reader> rrr;
	for (int pos=0; pos<value.size(); ++pos) {
		if (value[pos] == '?')
			continue;

		auto key =pos*10+value[pos]-'0';

		if (index.count(key) == 0) {
			done = true;
			break;
		}

		rrr.emplace_back(index[key]);
	}

	//cout << "rrr.size " << rrr.size() << endl;

	while(!done) { 
		int m = 0;

		for (auto &r : rrr) {
			m = max(m, r.list[r.i]);
		}

		//cout << "rrr.max " << m << endl;

		int cc = 0;
		for (auto &r : rrr) {

			while (r.i < r.list.size()  && r.list[r.i] < m) {
				r.i++;
			}
			//cout << "r.i " << r.i << endl;

			if (r.i < r.list.size()) {
				if (r.list[r.i] == m) {
					++cc;
					r.i++;
					if (r.i >= r.list.size())
						done = true;

				}
			} else {
				done = true;
				break;
			}
		}
		if (cc == rrr.size())
			cnt++;

	}

	cout << cnt << endl;
    }



#if 0
	int ok = 0;
	for (const std::string& f : filters) {
	    bool correct = true;
	    for (int i = 0; i < f.size(); ++i) {
		if (value[i] == '?') continue;
		if (value[i] != f[i]) { correct = false; break; }
	    }
	    ok += correct;
	}
	std::cout << ok << "\n";
    }
#endif

    return 0;
}
